#!/usr/bin/env bash

# Start with the default configuration
# Generates `.config` file
make defconfig

# Disable all enabled features that causes compile-time errors with emcc
# (for example, missing system headers)
sed -i \
  -e 's/CONFIG_ACPID=y/CONFIG_ACPID=n/' \
  -e 's/CONFIG_ADJTIMEX=y/CONFIG_ADJTIMEX=n/' \
  -e 's/CONFIG_BEEP=y/CONFIG_BEEP=n/' \
  -e 's/CONFIG_BLKDISCARD=y/CONFIG_BLKDISCARD=n/' \
  -e 's/CONFIG_BLOCKDEV=y/CONFIG_BLOCKDEV=n/' \
  -e 's/CONFIG_BRCTL=y/CONFIG_BRCTL=n/' \
  -e 's/CONFIG_CONSPY=y/CONFIG_CONSPY=n/' \
  -e 's/CONFIG_DEPMOD=y/CONFIG_DEPMOD=n/' \
  -e 's/CONFIG_DMESG=y/CONFIG_DMESG=n/' \
  -e 's/CONFIG_EJECT=y/CONFIG_EJECT=n/' \
  -e 's/CONFIG_ETHER_WAKE=y/CONFIG_ETHER_WAKE=n/' \
  -e 's/CONFIG_FBSPLASH=y/CONFIG_FBSPLASH=n/' \
  -e 's/CONFIG_FEATURE_IFCONFIG_SLIP=y/CONFIG_FEATURE_IFCONFIG_SLIP=n/' \
  -e 's/CONFIG_FEATURE_MDEV_DAEMON=y/CONFIG_FEATURE_MDEV_DAEMON=n/' \
  -e 's/CONFIG_FEATURE_MOUNT_LOOP=y/CONFIG_FEATURE_MOUNT_LOOP=n/' \
  -e 's/CONFIG_FEATURE_SETPRIV_CAPABILITIES=y/CONFIG_FEATURE_SETPRIV_CAPABILITIES=n/' \
  -e 's/CONFIG_FEATURE_USE_SENDFILE=y/CONFIG_FEATURE_USE_SENDFILE=n/' \
  -e 's/CONFIG_FREE=y/CONFIG_FREE=n/' \
  -e 's/CONFIG_FSFREEZE=y/CONFIG_FSFREEZE=n/' \
  -e 's/CONFIG_FSTRIM=y/CONFIG_FSTRIM=n/' \
  -e 's/CONFIG_HALT=y/CONFIG_HALT=n/' \
  -e 's/CONFIG_HDPARM=y/CONFIG_HDPARM=n/' \
  -e 's/CONFIG_I2CDETECT=y/CONFIG_I2CDETECT=n/' \
  -e 's/CONFIG_I2CDUMP=y/CONFIG_I2CDUMP=n/' \
  -e 's/CONFIG_I2CGET=y/CONFIG_I2CGET=n/' \
  -e 's/CONFIG_I2CSET=y/CONFIG_I2CSET=n/' \
  -e 's/CONFIG_I2CTRANSFER=y/CONFIG_I2CTRANSFER=n/' \
  -e 's/CONFIG_IFENSLAVE=y/CONFIG_IFENSLAVE=n/' \
  -e 's/CONFIG_IFPLUGD=y/CONFIG_IFPLUGD=n/' \
  -e 's/CONFIG_INIT=y/CONFIG_INIT=n/' \
  -e 's/CONFIG_INSMOD=y/CONFIG_INSMOD=n/' \
  -e 's/CONFIG_IONICE=y/CONFIG_IONICE=n/' \
  -e 's/CONFIG_IP=y/CONFIG_IP=n/' \
  -e 's/CONFIG_IPADDR=y/CONFIG_IPADDR=n/' \
  -e 's/CONFIG_IPLINK=y/CONFIG_IPLINK=n/' \
  -e 's/CONFIG_IPNEIGH=y/CONFIG_IPNEIGH=n/' \
  -e 's/CONFIG_IPROUTE=y/CONFIG_IPROUTE=n/' \
  -e 's/CONFIG_IPRULE=y/CONFIG_IPRULE=n/' \
  -e 's/CONFIG_IPTUNNEL=y/CONFIG_IPTUNNEL=n/' \
  -e 's/CONFIG_KBD_MODE=y/CONFIG_KBD_MODE=n/' \
  -e 's/CONFIG_KLOGD=y/CONFIG_KLOGD=n/' \
  -e 's/CONFIG_LINUX32=y/CONFIG_LINUX32=n/' \
  -e 's/CONFIG_LINUX64=y/CONFIG_LINUX64=n/' \
  -e 's/CONFIG_LINUXRC=y/CONFIG_LINUXRC=n/' \
  -e 's/CONFIG_LOADFONT=y/CONFIG_LOADFONT=n/' \
  -e 's/CONFIG_LOSETUP=y/CONFIG_LOSETUP=n/' \
  -e 's/CONFIG_LSMOD=y/CONFIG_LSMOD=n/' \
  -e 's/CONFIG_MDEV=y/CONFIG_MDEV=n/' \
  -e 's/CONFIG_MKDOSFS=y/CONFIG_MKDOSFS=n/' \
  -e 's/CONFIG_MKE2FS=y/CONFIG_MKE2FS=n/' \
  -e 's/CONFIG_MKFS_EXT2=y/CONFIG_MKFS_EXT2=n/' \
  -e 's/CONFIG_MKFS_VFAT=y/CONFIG_MKFS_VFAT=n/' \
  -e 's/CONFIG_MODINFO=y/CONFIG_MODINFO=n/' \
  -e 's/CONFIG_MODPROBE=y/CONFIG_MODPROBE=n/' \
  -e 's/CONFIG_MODPROBE_SMALL=y/CONFIG_MODPROBE_SMALL=n/' \
  -e 's/CONFIG_NAMEIF=y/CONFIG_NAMEIF=n/' \
  -e 's/CONFIG_NANDDUMP=y/CONFIG_NANDDUMP=n/' \
  -e 's/CONFIG_NANDWRITE=y/CONFIG_NANDWRITE=n/' \
  -e 's/CONFIG_NBDCLIENT=y/CONFIG_NBDCLIENT=n/' \
  -e 's/CONFIG_NTPD=y/CONFIG_NTPD=n/' \
  -e 's/CONFIG_OPENVT=y/CONFIG_OPENVT=n/' \
  -e 's/CONFIG_PARTPROBE=y/CONFIG_PARTPROBE=n/' \
  -e 's/CONFIG_POWEROFF=y/CONFIG_POWEROFF=n/' \
  -e 's/CONFIG_RAIDAUTORUN=y/CONFIG_RAIDAUTORUN=n/' \
  -e 's/CONFIG_REBOOT=y/CONFIG_REBOOT=n/' \
  -e 's/CONFIG_RMMOD=y/CONFIG_RMMOD=n/' \
  -e 's/CONFIG_RUN_INIT=y/CONFIG_RUN_INIT=n/' \
  -e 's/CONFIG_SEEDRNG=y/CONFIG_SEEDRNG=n/' \
  -e 's/CONFIG_SETARCH=y/CONFIG_SETARCH=n/' \
  -e 's/CONFIG_SETFONT=y/CONFIG_SETFONT=n/' \
  -e 's/CONFIG_SETPRIV=y/CONFIG_SETPRIV=n/' \
  -e 's/CONFIG_SHOWKEY=y/CONFIG_SHOWKEY=n/' \
  -e 's/CONFIG_SLATTACH=y/CONFIG_SLATTACH=n/' \
  -e 's/CONFIG_SWAPOFF=y/CONFIG_SWAPOFF=n/' \
  -e 's/CONFIG_SWAPON=y/CONFIG_SWAPON=n/' \
  -e 's/CONFIG_TC=y/CONFIG_TC=n/' \
  -e 's/CONFIG_TUNCTL=y/CONFIG_TUNCTL=n/' \
  -e 's/CONFIG_UBIATTACH=y/CONFIG_UBIATTACH=n/' \
  -e 's/CONFIG_UBIDETACH=y/CONFIG_UBIDETACH=n/' \
  -e 's/CONFIG_UBIMKVOL=y/CONFIG_UBIMKVOL=n/' \
  -e 's/CONFIG_UBIRENAME=y/CONFIG_UBIRENAME=n/' \
  -e 's/CONFIG_UBIRMVOL=y/CONFIG_UBIRMVOL=n/' \
  -e 's/CONFIG_UBIRSVOL=y/CONFIG_UBIRSVOL=n/' \
  -e 's/CONFIG_UBIUPDATEVOL=y/CONFIG_UBIUPDATEVOL=n/' \
  -e 's/CONFIG_UDHCPC6=y/CONFIG_UDHCPC6=n/' \
  -e 's/CONFIG_UDHCPC=y/CONFIG_UDHCPC=n/' \
  -e 's/CONFIG_UEVENT=y/CONFIG_UEVENT=n/' \
  -e 's/CONFIG_UPTIME=y/CONFIG_UPTIME=n/' \
  -e 's/CONFIG_WATCHDOG=y/CONFIG_WATCHDOG=n/' \
  -e 's/CONFIG_ZCIP=y/CONFIG_ZCIP=n/' \
  .config

# For all features with link time errors, either
# disable them completely in `.config`,
# or add stub functions (created by patches)
sed -i \
  -e 's/CONFIG_CHRT=y/CONFIG_CHRT=n/' \
  -e 's/CONFIG_FEATURE_SU_CHECKS_SHELLS=y/CONFIG_FEATURE_SU_CHECKS_SHELLS=n/' \
  -e 's/CONFIG_FEATURE_SYNC_FANCY=y/CONFIG_FEATURE_SYNC_FANCY=n/' \
  -e 's/CONFIG_FEATURE_UTMP=y/CONFIG_FEATURE_UTMP=n/' \
  -e 's/CONFIG_IPCRM=y/CONFIG_IPCRM=n/' \
  -e 's/CONFIG_IPCS=y/CONFIG_IPCS=n/' \
  -e 's/CONFIG_LOGGER=y/CONFIG_LOGGER=n/' \
  -e 's/CONFIG_LOGREAD=y/CONFIG_LOGREAD=n/' \
  -e 's/CONFIG_MOUNT=y/CONFIG_MOUNT=n/' \
  -e 's/CONFIG_NPROC=y/CONFIG_NPROC=n/' \
  -e 's/CONFIG_NSENTER=y/CONFIG_NSENTER=n/' \
  -e 's/CONFIG_PIVOT_ROOT=y/CONFIG_PIVOT_ROOT=n/' \
  -e 's/CONFIG_READAHEAD=y/CONFIG_READAHEAD=n/' \
  -e 's/CONFIG_RUN_INIT=y/CONFIG_RUN_INIT=n/' \
  -e 's/CONFIG_SETFATTR=y/CONFIG_SETFATTR=n/' \
  -e 's/CONFIG_SWITCH_ROOT=y/CONFIG_SWITCH_ROOT=n/' \
  -e 's/CONFIG_SYSLOGD=y/CONFIG_SYSLOGD=n/' \
  -e 's/CONFIG_TASKSET=y/CONFIG_TASKSET=n/' \
  -e 's/CONFIG_TIME=y/CONFIG_TIME=n/' \
  -e 's/CONFIG_UMOUNT=y/CONFIG_UMOUNT=n/' \
  -e 's/CONFIG_UNSHARE=y/CONFIG_UNSHARE=n/' \
  .config

# Fix runtime display issues
# To check which files have Unicode support:
#   git grep --files-with-matches ENABLE_UNICODE_SUPPORT
# in the BusyBox repository (https://git.busybox.net/busybox/tree/?h=1_36_0)
sed -i \
  -e '/CONFIG_FEATURE_CHECK_UNICODE_IN_ENV/c CONFIG_FEATURE_CHECK_UNICODE_IN_ENV=y' \
  .config

# Disable applets that cannot perform their main function at all
# (crashes, hangs, or has no effect in BusyBox Web)
sed -i \
  -e '/CONFIG_SH_IS_NONE/c CONFIG_SH_IS_NONE=y' \
  -e 's/CONFIG_ADD_SHELL=y/CONFIG_ADD_SHELL=n/' \
  -e 's/CONFIG_ADDUSER=y/CONFIG_ADDUSER=n/' \
  -e 's/CONFIG_ARP=y/CONFIG_ARP=n/' \
  -e 's/CONFIG_ARPING=y/CONFIG_ARPING=n/' \
  -e 's/CONFIG_ASH_JOB_CONTROL=y/CONFIG_ASH_JOB_CONTROL=n/' \
  -e 's/CONFIG_BASE32=y/CONFIG_BASE32=n/' \
  -e 's/CONFIG_BASE64=y/CONFIG_BASE64=n/' \
  -e 's/CONFIG_BB_SYSCTL=y/CONFIG_BB_SYSCTL=n/' \
  -e 's/CONFIG_BLKID=y/CONFIG_BLKID=n/' \
  -e 's/CONFIG_BOOTCHARTD=y/CONFIG_BOOTCHARTD=n/' \
  -e 's/CONFIG_BUNZIP2=y/CONFIG_BUNZIP2=n/' \
  -e 's/CONFIG_BZCAT=y/CONFIG_BZCAT=n/' \
  -e 's/CONFIG_BZIP2=y/CONFIG_BZIP2=n/' \
  -e 's/CONFIG_CHAT=y/CONFIG_CHAT=n/' \
  -e 's/CONFIG_CHATTR=y/CONFIG_CHATTR=n/' \
  -e 's/CONFIG_CHPASSWD=y/CONFIG_CHPASSWD=n/' \
  -e 's/CONFIG_CHPST=y/CONFIG_CHPST=n/' \
  -e 's/CONFIG_CHROOT=y/CONFIG_CHROOT=n/' \
  -e 's/CONFIG_CHVT=y/CONFIG_CHVT=n/' \
  -e 's/CONFIG_CLEAR=y/CONFIG_CLEAR=n/' \
  -e 's/CONFIG_CPIO=y/CONFIG_CPIO=n/' \
  -e 's/CONFIG_CROND=y/CONFIG_CROND=n/' \
  -e 's/CONFIG_CRONTAB=y/CONFIG_CRONTAB=n/' \
  -e 's/CONFIG_CTTYHACK=y/CONFIG_CTTYHACK=n/' \
  -e 's/CONFIG_DD=y/CONFIG_DD=n/' \
  -e 's/CONFIG_DEALLOCVT=y/CONFIG_DEALLOCVT=n/' \
  -e 's/CONFIG_DELUSER=y/CONFIG_DELUSER=n/' \
  -e 's/CONFIG_DEVMEM=y/CONFIG_DEVMEM=n/' \
  -e 's/CONFIG_DHCPRELAY=y/CONFIG_DHCPRELAY=n/' \
  -e 's/CONFIG_DNSD=y/CONFIG_DNSD=n/' \
  -e 's/CONFIG_DNSDOMAINNAME=y/CONFIG_DNSDOMAINNAME=n/' \
  -e 's/CONFIG_DPKG=y/CONFIG_DPKG=n/' \
  -e 's/CONFIG_DPKG_DEB=y/CONFIG_DPKG_DEB=n/' \
  -e 's/CONFIG_DUMPKMAP=y/CONFIG_DUMPKMAP=n/' \
  -e 's/CONFIG_DUMPLEASES=y/CONFIG_DUMPLEASES=n/' \
  -e 's/CONFIG_ED=y/CONFIG_ED=n/' \
  -e 's/CONFIG_EGREP=y/CONFIG_EGREP=n/' \
  -e 's/CONFIG_ENVDIR=y/CONFIG_ENVDIR=n/' \
  -e 's/CONFIG_ENVUIDGID=y/CONFIG_ENVUIDGID=n/' \
  -e 's/CONFIG_FAKEIDENTD=y/CONFIG_FAKEIDENTD=n/' \
  -e 's/CONFIG_FATATTR=y/CONFIG_FATATTR=n/' \
  -e 's/CONFIG_FBSET=y/CONFIG_FBSET=n/' \
  -e 's/CONFIG_FDFLUSH=y/CONFIG_FDFLUSH=n/' \
  -e 's/CONFIG_FDFORMAT=y/CONFIG_FDFORMAT=n/' \
  -e 's/CONFIG_FDISK=y/CONFIG_FDISK=n/' \
  -e 's/CONFIG_FEATURE_EDITING=y/CONFIG_FEATURE_EDITING=n/' \
  -e 's/CONFIG_FGCONSOLE=y/CONFIG_FGCONSOLE=n/' \
  -e 's/CONFIG_FGREP=y/CONFIG_FGREP=n/' \
  -e 's/CONFIG_FINDFS=y/CONFIG_FINDFS=n/' \
  -e 's/CONFIG_FLOCK=y/CONFIG_FLOCK=n/' \
  -e 's/CONFIG_FREERAMDISK=y/CONFIG_FREERAMDISK=n/' \
  -e 's/CONFIG_FSCK=y/CONFIG_FSCK=n/' \
  -e 's/CONFIG_FSCK_MINIX=y/CONFIG_FSCK_MINIX=n/' \
  -e 's/CONFIG_FTPD=y/CONFIG_FTPD=n/' \
  -e 's/CONFIG_FTPGET=y/CONFIG_FTPGET=n/' \
  -e 's/CONFIG_FTPPUT=y/CONFIG_FTPPUT=n/' \
  -e 's/CONFIG_FUSER=y/CONFIG_FUSER=n/' \
  -e 's/CONFIG_GETTY=y/CONFIG_GETTY=n/' \
  -e 's/CONFIG_GUNZIP=y/CONFIG_GUNZIP=n/' \
  -e 's/CONFIG_GZIP=y/CONFIG_GZIP=n/' \
  -e 's/CONFIG_HEXEDIT=y/CONFIG_HEXEDIT=n/' \
  -e 's/CONFIG_HUSH=y/CONFIG_HUSH=n/' \
  -e 's/CONFIG_HWCLOCK=y/CONFIG_HWCLOCK=n/' \
  -e 's/CONFIG_IFCONFIG=y/CONFIG_IFCONFIG=n/' \
  -e 's/CONFIG_IFDOWN=y/CONFIG_IFDOWN=n/' \
  -e 's/CONFIG_IFUP=y/CONFIG_IFUP=n/' \
  -e 's/CONFIG_INETD=y/CONFIG_INETD=n/' \
  -e 's/CONFIG_IOSTAT=y/CONFIG_IOSTAT=n/' \
  -e 's/CONFIG_IPCALC=y/CONFIG_IPCALC=n/' \
  -e 's/CONFIG_KILL=y/CONFIG_KILL=n/' \
  -e 's/CONFIG_KILLALL5=y/CONFIG_KILLALL5=n/' \
  -e 's/CONFIG_KILLALL=y/CONFIG_KILLALL=n/' \
  -e 's/CONFIG_LESS=y/CONFIG_LESS=n/' \
  -e 's/CONFIG_LINK=y/CONFIG_LINK=n/' \
  -e 's/CONFIG_LN=y/CONFIG_LN=n/' \
  -e 's/CONFIG_LOADKMAP=y/CONFIG_LOADKMAP=n/' \
  -e 's/CONFIG_LOGIN=y/CONFIG_LOGIN=n/' \
  -e 's/CONFIG_LPD=y/CONFIG_LPD=n/' \
  -e 's/CONFIG_LPQ=y/CONFIG_LPQ=n/' \
  -e 's/CONFIG_LPR=y/CONFIG_LPR=n/' \
  -e 's/CONFIG_LSATTR=y/CONFIG_LSATTR=n/' \
  -e 's/CONFIG_LSOF=y/CONFIG_LSOF=n/' \
  -e 's/CONFIG_LSPCI=y/CONFIG_LSPCI=n/' \
  -e 's/CONFIG_LSSCSI=y/CONFIG_LSSCSI=n/' \
  -e 's/CONFIG_LSUSB=y/CONFIG_LSUSB=n/' \
  -e 's/CONFIG_LZCAT=y/CONFIG_LZCAT=n/' \
  -e 's/CONFIG_LZMA=y/CONFIG_LZMA=n/' \
  -e 's/CONFIG_LZOP=y/CONFIG_LZOP=n/' \
  -e 's/CONFIG_MAKEDEVS=y/CONFIG_MAKEDEVS=n/' \
  -e 's/CONFIG_MAN=y/CONFIG_MAN=n/' \
  -e 's/CONFIG_MESG=y/CONFIG_MESG=n/' \
  -e 's/CONFIG_MICROCOM=y/CONFIG_MICROCOM=n/' \
  -e 's/CONFIG_MIM=y/CONFIG_MIM=n/' \
  -e 's/CONFIG_MKFIFO=y/CONFIG_MKFIFO=n/' \
  -e 's/CONFIG_MKFS_MINIX=y/CONFIG_MKFS_MINIX=n/' \
  -e 's/CONFIG_MKSWAP=y/CONFIG_MKSWAP=n/' \
  -e 's/CONFIG_MORE=y/CONFIG_MORE=n/' \
  -e 's/CONFIG_MPSTAT=y/CONFIG_MPSTAT=n/' \
  -e 's/CONFIG_MT=y/CONFIG_MT=n/' \
  -e 's/CONFIG_NC=y/CONFIG_NC=n/' \
  -e 's/CONFIG_NETSTAT=y/CONFIG_NETSTAT=n/' \
  -e 's/CONFIG_NICE=y/CONFIG_NICE=n/' \
  -e 's/CONFIG_NMETER=y/CONFIG_NMETER=n/' \
  -e 's/CONFIG_NOHUP=y/CONFIG_NOHUP=n/' \
  -e 's/CONFIG_NOLOGIN=y/CONFIG_NOLOGIN=n/' \
  -e 's/CONFIG_NSLOOKUP=y/CONFIG_NSLOOKUP=n/' \
  -e 's/CONFIG_PASSWD=y/CONFIG_PASSWD=n/' \
  -e 's/CONFIG_PATCH=y/CONFIG_PATCH=n/' \
  -e 's/CONFIG_PGREP=y/CONFIG_PGREP=n/' \
  -e 's/CONFIG_PIDOF=y/CONFIG_PIDOF=n/' \
  -e 's/CONFIG_PING6=y/CONFIG_PING6=n/' \
  -e 's/CONFIG_PING=y/CONFIG_PING=n/' \
  -e 's/CONFIG_PIPE_PROGRESS=y/CONFIG_PIPE_PROGRESS=n/' \
  -e 's/CONFIG_PKILL=y/CONFIG_PKILL=n/' \
  -e 's/CONFIG_PMAP=y/CONFIG_PMAP=n/' \
  -e 's/CONFIG_POPMAILDIR=y/CONFIG_POPMAILDIR=n/' \
  -e 's/CONFIG_POWERTOP=y/CONFIG_POWERTOP=n/' \
  -e 's/CONFIG_PS=y/CONFIG_PS=n/' \
  -e 's/CONFIG_PSCAN=y/CONFIG_PSCAN=n/' \
  -e 's/CONFIG_PSTREE=y/CONFIG_PSTREE=n/' \
  -e 's/CONFIG_PWDX=y/CONFIG_PWDX=n/' \
  -e 's/CONFIG_RDATE=y/CONFIG_RDATE=n/' \
  -e 's/CONFIG_RDEV=y/CONFIG_RDEV=n/' \
  -e 's/CONFIG_READLINK=y/CONFIG_READLINK=n/' \
  -e 's/CONFIG_READPROFILE=y/CONFIG_READPROFILE=n/' \
  -e 's/CONFIG_REFORMIME=y/CONFIG_REFORMIME=n/' \
  -e 's/CONFIG_REMOVE_SHELL=y/CONFIG_REMOVE_SHELL=n/' \
  -e 's/CONFIG_RENICE=y/CONFIG_RENICE=n/' \
  -e 's/CONFIG_RESET=y/CONFIG_RESET=n/' \
  -e 's/CONFIG_RESIZE=y/CONFIG_RESIZE=n/' \
  -e 's/CONFIG_RESUME=y/CONFIG_RESUME=n/' \
  -e 's/CONFIG_ROUTE=y/CONFIG_ROUTE=n/' \
  -e 's/CONFIG_RPM2CPIO=y/CONFIG_RPM2CPIO=n/' \
  -e 's/CONFIG_RPM=y/CONFIG_RPM=n/' \
  -e 's/CONFIG_RTCWAKE=y/CONFIG_RTCWAKE=n/' \
  -e 's/CONFIG_RUN_PARTS=y/CONFIG_RUN_PARTS=n/' \
  -e 's/CONFIG_RUNSV=y/CONFIG_RUNSV=n/' \
  -e 's/CONFIG_RUNSVDIR=y/CONFIG_RUNSVDIR=n/' \
  -e 's/CONFIG_RX=y/CONFIG_RX=n/' \
  -e 's/CONFIG_SCRIPT=y/CONFIG_SCRIPT=n/' \
  -e 's/CONFIG_SCRIPTREPLAY=y/CONFIG_SCRIPTREPLAY=n/' \
  -e 's/CONFIG_SENDMAIL=y/CONFIG_SENDMAIL=n/' \
  -e 's/CONFIG_SETCONSOLE=y/CONFIG_SETCONSOLE=n/' \
  -e 's/CONFIG_SETKEYCODES=y/CONFIG_SETKEYCODES=n/' \
  -e 's/CONFIG_SETLOGCONS=y/CONFIG_SETLOGCONS=n/' \
  -e 's/CONFIG_SETSERIAL=y/CONFIG_SETSERIAL=n/' \
  -e 's/CONFIG_SETSID=y/CONFIG_SETSID=n/' \
  -e 's/CONFIG_SETUIDGID=y/CONFIG_SETUIDGID=n/' \
  -e 's/CONFIG_SH_IS_ASH=y/CONFIG_SH_IS_ASH=n/' \
  -e 's/CONFIG_SHELL_HUSH=y/CONFIG_SHELL_HUSH=n/' \
  -e 's/CONFIG_SHRED=y/CONFIG_SHRED=n/' \
  -e 's/CONFIG_SMEMCAP=y/CONFIG_SMEMCAP=n/' \
  -e 's/CONFIG_SOFTLIMIT=y/CONFIG_SOFTLIMIT=n/' \
  -e 's/CONFIG_SPLIT=y/CONFIG_SPLIT=n/' \
  -e 's/CONFIG_SSL_CLIENT=y/CONFIG_SSL_CLIENT=n/' \
  -e 's/CONFIG_START_STOP_DAEMON=y/CONFIG_START_STOP_DAEMON=n/' \
  -e 's/CONFIG_STTY=y/CONFIG_STTY=n/' \
  -e 's/CONFIG_SU=y/CONFIG_SU=n/' \
  -e 's/CONFIG_SULOGIN=y/CONFIG_SULOGIN=n/' \
  -e 's/CONFIG_SV=y/CONFIG_SV=n/' \
  -e 's/CONFIG_SVC=y/CONFIG_SVC=n/' \
  -e 's/CONFIG_SVLOGD=y/CONFIG_SVLOGD=n/' \
  -e 's/CONFIG_SVOK=y/CONFIG_SVOK=n/' \
  -e 's/CONFIG_SYNC=y/CONFIG_SYNC=n/' \
  -e 's/CONFIG_TAR=y/CONFIG_TAR=n/' \
  -e 's/CONFIG_TCPSVD=y/CONFIG_TCPSVD=n/' \
  -e 's/CONFIG_TELNET=y/CONFIG_TELNET=n/' \
  -e 's/CONFIG_TELNETD=y/CONFIG_TELNETD=n/' \
  -e 's/CONFIG_TFTP=y/CONFIG_TFTP=n/' \
  -e 's/CONFIG_TFTPD=y/CONFIG_TFTPD=n/' \
  -e 's/CONFIG_TIMEOUT=y/CONFIG_TIMEOUT=n/' \
  -e 's/CONFIG_TOP=y/CONFIG_TOP=n/' \
  -e 's/CONFIG_TRACEROUTE6=y/CONFIG_TRACEROUTE6=n/' \
  -e 's/CONFIG_TRACEROUTE=y/CONFIG_TRACEROUTE=n/' \
  -e 's/CONFIG_TTY=y/CONFIG_TTY=n/' \
  -e 's/CONFIG_UDHCPD=y/CONFIG_UDHCPD=n/' \
  -e 's/CONFIG_UDPSVD=y/CONFIG_UDPSVD=n/' \
  -e 's/CONFIG_UNEXPAND=y/CONFIG_UNEXPAND=n/' \
  -e 's/CONFIG_UNIQ=y/CONFIG_UNIQ=n/' \
  -e 's/CONFIG_UNLZMA=y/CONFIG_UNLZMA=n/' \
  -e 's/CONFIG_UNXZ=y/CONFIG_UNXZ=n/' \
  -e 's/CONFIG_UNZIP=y/CONFIG_UNZIP=n/' \
  -e 's/CONFIG_UUDECODE=y/CONFIG_UUDECODE=n/' \
  -e 's/CONFIG_UUENCODE=y/CONFIG_UUENCODE=n/' \
  -e 's/CONFIG_VCONFIG=y/CONFIG_VCONFIG=n/' \
  -e 's/CONFIG_VI=y/CONFIG_VI=n/' \
  -e 's/CONFIG_VLOCK=y/CONFIG_VLOCK=n/' \
  -e 's/CONFIG_VOLNAME=y/CONFIG_VOLNAME=n/' \
  -e 's/CONFIG_WATCH=y/CONFIG_WATCH=n/' \
  -e 's/CONFIG_WGET=y/CONFIG_WGET=n/' \
  -e 's/CONFIG_WHICH=y/CONFIG_WHICH=n/' \
  -e 's/CONFIG_WHOIS=y/CONFIG_WHOIS=n/' \
  -e 's/CONFIG_XARGS=y/CONFIG_XARGS=n/' \
  -e 's/CONFIG_XZ=y/CONFIG_XZ=n/' \
  -e 's/CONFIG_XZCAT=y/CONFIG_XZCAT=n/' \
  -e 's/CONFIG_YES=y/CONFIG_YES=n/' \
  -e 's/CONFIG_ZCAT=y/CONFIG_ZCAT=n/' \
  .config

# Enable NOFORK for all applets
# (changes "# <option> is not set" to "<option>=y")
sed -i \
  -e '/CONFIG_FEATURE_PREFER_APPLETS/c CONFIG_FEATURE_PREFER_APPLETS=y' \
  -e '/CONFIG_FEATURE_SH_NOFORK/c CONFIG_FEATURE_SH_NOFORK=y' \
  -e '/CONFIG_FEATURE_SH_STANDALONE/c CONFIG_FEATURE_SH_STANDALONE=y' \
  .config
